using System;
using System.Collections;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;
using setPoint.weaving;
using setPoint.messageReifying;

namespace LENDLConfiguration
{
	/// <summary>
	/// Avoids recalculating results of the message by caching them into a Hashtable
	/// </summary>
	public class DistributionAspect : IAspect
	{		
		static DistributionAspect()
		{
			DistributionAspect.initializeRemoting();			
		}

		public DistributionAspect(){
		}

		public void createRemoteObject(setPoint.messageReifying.IJoinPoint aJoinpoint)
		{								
			string url = "http://localhost:1234/MyServer";
			System.Runtime.Remoting.Activation.UrlAttribute urlattr = new System.Runtime.Remoting.Activation.UrlAttribute (url);
			object[] args = {urlattr};
			aJoinpoint.returnValue = Activator.CreateInstance(aJoinpoint.receiver.type,null,args);			
		}

		public bool mustCancelExecution
		{
			get { return true; }
		}

		private static void initializeRemoting()
		{
			BinaryServerFormatterSinkProvider serverProv = new BinaryServerFormatterSinkProvider();
			serverProv.TypeFilterLevel = System.Runtime.Serialization.Formatters.TypeFilterLevel.Full;
			BinaryClientFormatterSinkProvider clientProv = new BinaryClientFormatterSinkProvider();
			IDictionary props = new Hashtable();
			props["port"] = 0;
			HttpChannel chan = new HttpChannel(props, clientProv, serverProv);        
			ChannelServices.RegisterChannel( chan );	
		}
	}
}
