using System;
using dotSenku.Model;

namespace dotSenku.Model.Builders
{
	/// <summary>
	/// Builds a new cross board
	/// </summary>
	public class CrossBoardBuilder
	{
		public CrossBoardBuilder()
		{			
		}

		/// <summary>
		/// builds a cross board
		/// </summary>
		/// <param name="aWidth"></param>
		/// <param name="anHeight"></param>
		/// <param name="aCrossWidth"></param>
		/// <param name="aCrossHeight"></param>
		/// <returns></returns>
		public Board build(int aWidth, int anHeight, int aCrossWidth, int aCrossHeight)
		{		
			int xBegin = ( ( aWidth - aCrossWidth ) / 2 );
			int yBegin = ( ( anHeight - aCrossHeight ) / 2 );
			Board aBoard = new Board(aWidth, anHeight);		
			aBoard.enableRectangularAreaFrom(xBegin, 0, aCrossWidth, anHeight);
			aBoard.enableRectangularAreaFrom(0, yBegin, aWidth, aCrossHeight);		
			aBoard.setRectangularAreaFrom(xBegin, 0, aCrossWidth, anHeight / 2 );
 			aBoard.setRectangularAreaFrom(xBegin, anHeight / 2 + 1, aCrossWidth, anHeight / 2);
			aBoard.setRectangularAreaFrom(0, yBegin, aWidth / 2, aCrossHeight);
			aBoard.setRectangularAreaFrom(aWidth / 2 + 1, yBegin, aWidth /2, aCrossHeight);
			return aBoard;
		}
		
																					
	}
}
