using System;
using dotSenku.Model;

namespace dotSenku.Model.Builders
{
	/// <summary>
	/// Builds a new square board
	/// </summary>
	public class SquareBoardBuilder
	{
		public SquareBoardBuilder()
		{			
		}

		/// <summary>
		/// builds a square board
		/// </summary>
		/// <param name="aWidth"></param>
		/// <param name="anHeight"></param>
		/// <returns></returns>
		public Board build(int aWidth, int anHeight)
		{					
			Board aBoard = new Board(aWidth, anHeight);		
			aBoard.enableRectangularAreaFrom(0, 0 , aWidth, anHeight);
			aBoard.setRectangularAreaFrom(0, 0 , aWidth, anHeight);
			return aBoard;
		}

		/// <summary>
		/// builds a square board
		/// </summary>
		/// <param name="aWidth"></param>
		/// <param name="anHeight"></param>
		/// <returns></returns>
		public Board build(int aWidth, int anHeight, int aSquareWidth, int aSquareHeight)
		{					
			Board aBoard = new Board(aWidth, anHeight);		
			aBoard.enableRectangularAreaFrom(0, 0 , aWidth, anHeight);
			aBoard.setRectangularAreaFrom( (aWidth - aSquareWidth) / 2, (anHeight - aSquareHeight) / 2, aSquareWidth, aSquareHeight);
			return aBoard;
		}

	}
}
