using System;
using dotSenku.Model;
using dotSenku.Model.Movements;

namespace dotSenku.Model.CountingRules
{
	/// <summary>
	/// Movements counting rule for a specific Senku rule
	/// </summary>
	public abstract class CountingRule : MarshalByRefObject
	{
		public CountingRule()
		{
		}

		public event NoParams onMovementCountChanged;
		private int _count = 0;
		/// <summary>
		/// returns the current count
		/// </summary>
		public int currentCount
		{
			get { return this._count; }
		}

		/// <summary>
		///  decides whether the movement is part of a new movements, and count it
		/// </summary>
		/// <param name="aMovement"></param>
		public abstract void count(Movement aMovement);
				 
				
		/// <summary>
		/// increments the counter
		/// </summary>
		public void increment()
		{
			this._count++;
			if (this.onMovementCountChanged != null)
				this.onMovementCountChanged();
		}

	}
}
