using System;
using dotSenku.Model;
using dotSenku.Model.Movements;

namespace dotSenku.Model.CountingRules
{
	/// <summary>
	/// New movement is counted only when you change the peg you are using
	/// </summary>
	public class PegMovementCounter : CountingRule
	{
		public PegMovementCounter()
		{			
		}
		
		private Peg _peg;
		/// <summary>
		/// last peg used
		/// </summary>
		public Peg peg 
		{
			get { return this._peg; }
			set { this._peg = value; }
		}
		

		/// <summary>
		/// increments the movement only when another peg is used
		/// </summary>
		/// <param name="aMovement"></param>
		override public void count(Movement aMovement)
		{
			if (aMovement.peg != this.peg )
			{
				this.increment();
				this.peg = aMovement.peg;			
			}
		}

	}
}
