using System;
using dotSenku.Model;

namespace dotSenku.Model.Movements
{
	/// <summary>
	/// Peg Movement
	/// </summary>
	public abstract class Movement : MarshalByRefObject
	{
		public Movement()
		{		
		}

		public Movement(Square source, Square target)
		{		
			this.source = source;
			this.target = target;
		}

		private Peg _peg;
		/// <summary>
		/// peg being moved
		/// </summary>
		public Peg peg
		{
			get { return this._peg; }
			set { this._peg = value; }
		}
		
		private Square _source;
		/// <summary>
		/// Movement source square
		/// </summary>
		public Square source
		{
			get { return this._source; }
			set 
			{ 
				this._source = value; 
				this.peg = value.peg;
			}
		}

		private Square _target;
		/// <summary>
		/// Movement target square
		/// </summary>
		public Square target
		{
			get { return this._target; }
			set { this._target = value; }
		}
		
		/// <summary>
		/// executes the movement
		/// </summary>
		public abstract void execute();		
		

	}
}
