using System;
using System.Collections;
using dotSenku.Model;

namespace dotSenku.Model.Movements
{
	/// <summary>
	/// Define which are the possible movements from the specified square in the given board
	/// </summary>
	public abstract class MovementFactory
	{
		
		
		/// <summary>
		/// returns the posible movements of a specific kind that can be executed on this board 
		/// </summary>
		/// <param name="aSquare"></param>
		/// <param name="aBoard"></param>
		/// <returns></returns>
		public abstract ICollection potentialMovementsFor(Square aSquare, Board aBoard);

	}
}
