using System;
using System.Collections;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels.Http;
using System.Runtime.Remoting.Channels;
using dotSenku.Model.Builders;

namespace Server
{

	public class MyRemoteObject: MarshalByRefObject
	{
		int myvalue;

		public MyRemoteObject(int val)
		{
			Console.WriteLine("MyRemoteObject.ctor(int) called");
			myvalue = val;
		}

		public MyRemoteObject()
		{
			Console.WriteLine("MyRemoteObject.ctor() called");
		}

		public void setValue(int newval)
		{
			Console.WriteLine("MyRemoteObject.setValue(): old {0} new {1}",
				myvalue,newval);
			myvalue = newval;
		}

		public int getValue()
		{
			Console.WriteLine("MyRemoteObject.getValue(): current {0}",myvalue);
			return myvalue;
		}
	}
	class ServerStartup
	{
		static void Main(string[] args)
		{
			Console.WriteLine ("ServerStartup.Main(): Server started");
			//HttpChannel chnl = new HttpChannel(1234);
			//ChannelServices.RegisterChannel(chnl);
			BinaryServerFormatterSinkProvider serverProv = new BinaryServerFormatterSinkProvider();
			serverProv.TypeFilterLevel = System.Runtime.Serialization.Formatters.TypeFilterLevel.Full;
			BinaryClientFormatterSinkProvider clientProv = new BinaryClientFormatterSinkProvider();
			IDictionary props = new Hashtable();
			props["port"] = 1234;
			HttpChannel chan = new HttpChannel(props, clientProv, serverProv);        
			ChannelServices.RegisterChannel( chan );

			RemotingConfiguration.ApplicationName = "MyServer";
			RemotingConfiguration.RegisterActivatedServiceType(
				typeof(MyRemoteObject));
			RemotingConfiguration.RegisterActivatedServiceType(typeof(SenkuBuilder)) ;
			RemotingConfiguration.RegisterActivatedServiceType(typeof(DudeneyBuilder)) ;
			RemotingConfiguration.RegisterActivatedServiceType(typeof(GardnerBuilder)) ;
			RemotingConfiguration.RegisterActivatedServiceType(typeof(LloydBuilder)) ;

			// the server will keep running until keypress.
			Console.ReadLine();
		}
	}
}

