using System;
using dotSenku.Model;

namespace dotSenku.Model.Movements
{
	/// <summary>
	/// JumpMovement.
	/// </summary>
	public class JumpMovement : Movement
	{
		public JumpMovement()
		{
		}

		public JumpMovement(Square source, Square middle, Square target) : base(source, target)
		{
			this.over = middle;
		}


		private Square _over;
		/// <summary>
		/// square located between the souce and the target
		/// </summary>
		public Square over
		{
			get { return this._over; }
			set { this._over = value; }
		}
		
		/// <summary>
		/// jump movement execution
		/// </summary>
		override public void execute()
		{
			this.target.peg = this.source.free();
			this.over.free();
		}

		
	}
}
