using System;
using System.Collections;

namespace dotSenku.Model.Movements
{
	/// <summary>
	/// MovementRule.
	/// </summary>
	public class MovementRule
	{
		public MovementRule()
		{	
		}

		public MovementRule(ICollection factories)
		{	
			this.factories = factories;
		}

		private ICollection _factories;
		/// <summary>
		/// movement factories that contains this movement rule
		/// </summary>
		public ICollection factories
		{
			get { return this._factories; }
			set { this._factories = value; }
		}

		/// <summary>
		/// returns he posible movements that can be executed on the given board
		/// </summary>
		/// <returns></returns>
		public ICollection potentialMovementsFor(Square aSquare, Board aBoard)
		{			
			ArrayList movements = new ArrayList();					
			foreach(MovementFactory factory in this.factories)
				movements.AddRange(factory.potentialMovementsFor(aSquare, aBoard));
			return movements;
		}

	}
}
