using System;

namespace dotSenku.Model
{
	public delegate void NoParams();

	/// <summary>
	/// Single square of the board.
	/// </summary>	
	public class Square: MarshalByRefObject
	{

		public Square()
		{
		}

		public event NoParams onSquareSet;
		public event NoParams onSquareFreed;

		private Peg _peg;
		public Peg peg
		{
			get { return this._peg; }
			set
			{	
				this._peg = value;
				if ((value != null)&&(this.onSquareSet != null))
					this.onSquareSet(); 
			}
		}

		/// <summary>
		/// takes out the peg from the square
		/// </summary>
		public Peg free()
		{			
			Peg currentPeg = this.peg;
			this.peg = null;
			if (this.onSquareFreed != null)
				this.onSquareFreed();
			return currentPeg;
		}
			
		/// <summary>
		/// indicates if a peg is set on the square
		/// </summary>
		public bool isSet
		{
			get { return (this.peg != null); }
		}						 

	}
}
