using System;
using System.Drawing;
using System.Windows.Forms;

namespace dotSenku.View {
	/// <summary>
	/// Summary description for PegMorph.
	/// </summary>
	public class PegMorph : System.Windows.Forms.UserControl {
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		protected System.Drawing.Color _color = System.Drawing.Color.Red;

		public PegMorph(System.Reflection.MethodBase action, object target) {
			InitializeComponent();
			this.action = action;
			this.target = target;
			this.enabled = true;
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing) {
			if (disposing) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Component Designer generated code

		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			// 
			// PegMorph
			// 
			this.BackColor = System.Drawing.Color.LightSkyBlue;
			this.Cursor = System.Windows.Forms.Cursors.Hand;
			this.Name = "PegMorph";
			this.Size = new System.Drawing.Size(24, 24);
			this.MouseEnter += new EventHandler(PegMorph_MouseEnter);
			this.MouseLeave += new EventHandler(PegMorph_MouseLeave);
			this.Click += new EventHandler(PegMorph_Click);

		}

		#endregion

		#region properties

		private System.Reflection.MethodBase _action;

		public System.Reflection.MethodBase action {
			get { return this._action; }
			set { this._action = value; }
		}

		private object _target;

		public object target {
			get { return this._target; }
			set { this._target = value; }
		}

		private bool _enabled;

		public bool enabled {
			get { return this._enabled; }
			set {
				this._enabled = value;
				if (value)
					this.Cursor = System.Windows.Forms.Cursors.Hand;
				else
					this.Cursor = System.Windows.Forms.Cursors.Default;
			}
		}

		#endregion

		private void PegMorph_MouseEnter(object sender, EventArgs e) {
			if (this.enabled) {
				this._color = System.Drawing.Color.White;
				this.Refresh();
			}
		}

		private void PegMorph_MouseLeave(object sender, EventArgs e) {
			if (this.enabled) {
				this._color = System.Drawing.Color.Red;
				this.Refresh();
			}

		}

		private void PegMorph_Click(object sender, EventArgs e) {
			if (this.enabled)
				this.action.Invoke(this.target, new object[0]);
		}

		override protected void OnPaint(PaintEventArgs e) {
			Graphics graphics = e.Graphics;
			Pen pen = new Pen(Color.Black, 4);
			SolidBrush brush = new SolidBrush(this._color);
			graphics.DrawEllipse(pen, 2, 2, this.Width - 4, this.Height - 4);
			graphics.FillEllipse(brush, 3, 3, this.Width - 6, this.Height - 6);
		}

	}
}