using System;
using System.Collections;
using System.Windows.Forms;
using dotSenku.Model;

namespace dotSenku.View {
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmPlayRoom : System.Windows.Forms.Form {
		private System.Windows.Forms.Label lblTitle;
		private System.Windows.Forms.ComboBox cboGame;
		private System.Windows.Forms.Label lnTitleUnderline;
		private dotSenku.View.MovementCounterMorph movementCounter;
		private dotSenku.View.EndingMorph ending;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmPlayRoom() {
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing) {
			if (disposing) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.lblTitle = new System.Windows.Forms.Label();
			this.cboGame = new System.Windows.Forms.ComboBox();
			this.lnTitleUnderline = new System.Windows.Forms.Label();
			this.movementCounter = new dotSenku.View.MovementCounterMorph();
			this.ending = new dotSenku.View.EndingMorph();
			this.SuspendLayout();
			// 
			// lblTitle
			// 
			this.lblTitle.Font = new System.Drawing.Font("Arial", 21.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte) (0)));
			this.lblTitle.Location = new System.Drawing.Point(8, 16);
			this.lblTitle.Name = "lblTitle";
			this.lblTitle.Size = new System.Drawing.Size(248, 24);
			this.lblTitle.TabIndex = 0;
			this.lblTitle.Text = "Dot Senku!";
			this.lblTitle.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// cboGame
			// 
			this.cboGame.DisplayMember = "0";
			this.cboGame.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboGame.Items.AddRange(new object[] {
				"Senku",
				"Dudeney",
				"Gardner",
				"Lloyd"
			});
			this.cboGame.Location = new System.Drawing.Point(8, 56);
			this.cboGame.Name = "cboGame";
			this.cboGame.Size = new System.Drawing.Size(112, 21);
			this.cboGame.TabIndex = 3;
			this.cboGame.SelectedIndexChanged += new System.EventHandler(this.cboGame_selectedIndexChange);
			// 
			// lnTitleUnderline
			// 
			this.lnTitleUnderline.BackColor = System.Drawing.Color.Black;
			this.lnTitleUnderline.Location = new System.Drawing.Point(0, 48);
			this.lnTitleUnderline.Name = "lnTitleUnderline";
			this.lnTitleUnderline.Size = new System.Drawing.Size(260, 1);
			this.lnTitleUnderline.TabIndex = 4;
			// 
			// movementCounter
			// 
			this.movementCounter.BackColor = System.Drawing.Color.Black;
			this.movementCounter.countingRule = null;
			this.movementCounter.Location = new System.Drawing.Point(8, 80);
			this.movementCounter.Name = "movementCounter";
			this.movementCounter.Size = new System.Drawing.Size(250, 40);
			this.movementCounter.TabIndex = 0;
			// 
			// ending
			// 
			this.ending.BackColor = System.Drawing.Color.Blue;
			this.ending.Location = new System.Drawing.Point(20, 192);
			this.ending.Name = "ending";
			this.ending.TabIndex = 5;
			this.ending.Visible = false;
			// 
			// frmPlayRoom
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Info;
			this.ClientSize = new System.Drawing.Size(264, 382);
			this.Controls.Add(this.ending);
			this.Controls.Add(this.movementCounter);
			this.Controls.Add(this.lnTitleUnderline);
			this.Controls.Add(this.cboGame);
			this.Controls.Add(this.lblTitle);
			this.Name = "frmPlayRoom";
			this.Text = "Senku";
			this.Load += new System.EventHandler(this.PlayRoom_Load);
			this.ResumeLayout(false);

		}

		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() {
			Application.Run(new frmPlayRoom());
		}

		private void PlayRoom_Load(object sender, System.EventArgs e) {
			//this.cboGame.SelectedIndex = 0;
		}

		private void cboGame_selectedIndexChange(object sender, System.EventArgs e) {
			if (this.board != null)
				this.board.Dispose();
			dotSenku.Model.Builders.GameBuilder game = null;
			switch (this.cboGame.SelectedIndex) {
				case 0:
					game = new dotSenku.Model.Builders.SenkuBuilder();
					this.startGame(game);
					break;
				case 1:
					this.startGame(new dotSenku.Model.Builders.DudeneyBuilder());
					break;
				case 2:
					this.startGame(new dotSenku.Model.Builders.GardnerBuilder());
					break;
				case 3:
					this.startGame(new dotSenku.Model.Builders.LloydBuilder());
					break;
			}
		}

		#region properties

		private dotSenku.Model.Game _game;

		public dotSenku.Model.Game game {
			get { return this._game; }
			set {
				this._game = value;
				this.initializeGame(value);
			}
		}

		private dotSenku.View.BoardMorph _board;

		public dotSenku.View.BoardMorph board {
			get { return this._board; }
			set { this._board = value; }
		}

		#endregion

		#region initialization

		public void initializeGame(dotSenku.Model.Game aGame) {
			this.createBoardOn(aGame);
			aGame.onPotentialMovementsRequired += new CollAsParam(this.potentialMovementsAre);
			aGame.onLost += new NoParams(this.lost);
			aGame.onWon += new NoParams(this.won);
			this.movementCounter.countingRule = this.game.countingRule;
			this.ending.initialize();
		}

		public void createBoardOn(dotSenku.Model.Game aGame) {
			this.board = new dotSenku.View.BoardMorph(this, aGame.board);
			this.board.Left = 8;
			this.board.Top = 125;
			this.board.enabled = true;
			this.Controls.Add(this.board);
		}

		#endregion

		#region Events-Processing

		public void startGame(dotSenku.Model.Builders.GameBuilder aBuilder) 
		{
			this.game = aBuilder.build();
		}

		/// <summary>
		/// player has just lost the game - disable board and show corresponding ending
		/// </summary>
		public void lost() 
		{
			if (this.InvokeRequired)			
				this.BeginInvoke(new MethodInvoker(this.lostInThread));
			else
				this.lostInThread();	
		}

		private void lostInThread()
		{
			this.board.enabled = false;
			this.ending.lost();
		}

		/// <summary>
		/// player has just won the game - disable board and show corresponding ending
		/// </summary>
		public void won() 
		{
			if (this.InvokeRequired)			
				this.BeginInvoke(new MethodInvoker(this.wonInThread));
			else
				this.wonInThread();	
		}

		private void wonInThread()
		{
			this.board.enabled = false;
			this.ending.won();
		}

		/// <summary>
		/// these are the potential movements for aSquare, as requested
		/// </summary>
		/// <param name="aMovementCollection"></param>
		public void potentialMovementsAre(ICollection aMovementCollection) 
		{
			if (this.InvokeRequired)
			{
				object[] parameters = new object[1];
				parameters[0] = aMovementCollection;
				this.BeginInvoke(new dotSenku.Model.CollAsParam(this.potentialMovementsAreInThread), parameters);
			}
			else
				this.potentialMovementsAreInThread(aMovementCollection);	
		}

		private void potentialMovementsAreInThread(ICollection aMovementCollection) 
		{
			if (aMovementCollection.Count > 0) 
			{
				if (aMovementCollection.Count == 1)
					foreach (dotSenku.Model.Movements.Movement aMovement in aMovementCollection)
						this.execute(aMovement);
				else 
				{
					this.board.enabled = false;
					this.board.createPotentialMovementsOn(this, aMovementCollection);
				}
			}
		}

		#endregion

		#region game management

		/// <summary>
		/// asks current game to generate potential movements from aSquare - 
		/// answer is ignored because an event is expected
		/// </summary>
		/// <param name="aSquare"></param>
		public void playerWantsToMoveFrom(dotSenku.View.VisibleSquareMorph aSquare) {
			this.game.playerWantsToMoveFrom(aSquare.square);
		}

		/// <summary>
		/// delegates execution of movement to current game
		/// </summary>
		/// <param name="aMovement"></param>
		public void execute(dotSenku.Model.Movements.Movement aMovement) {
			this.game.execute(aMovement);
			this.board.enabled = true;
		}

		#endregion
	}
}